/*
 * Hamsam - Instant Messaging API
 * Copyright (C) 2003 Raghu K
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package gui.action;

import gui.ContactsMgrPanel;
import gui.MainFrame;
import gui.tools.PropertiesManager;
import hamsam.api.Buddy;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Vector;

/**
 *
 * @author  Fr?d?ric DIB
 */
public class LaunchChat implements ActionListener
{
	private PropertiesManager propertiesMgr = null;
	private MainFrame owner = null;
	private ContactsMgrPanel contacts = null;

	/** Creates a new instance of LaunchChat */
	public LaunchChat(PropertiesManager p, MainFrame o, ContactsMgrPanel c)
	{
		this.propertiesMgr = p;
		this.owner = o;
		this.contacts = c;
	}

	/** Invoked when an action occurs.
	 *
	 */
	public void actionPerformed(ActionEvent evt)
	{
		Vector v = new Vector();
		Buddy[] buds = this.contacts.getSelectedBuddies();
		for (int i = 0; i < buds.length; i++)
		{
			v.addElement(buds[i]);
		}
		owner.addChatPanel(v);
	}

}
